]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Merge pull request #29 from esc/feature/silence_cowsay
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index ae0fa68afb02da9d7fddb271da9b7cbb2c96bc0f..c6ea395476b0759e059db930b8e5013b13acb02b 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -1,8 +1,19 @@
 #!/bin/sh
 
-[ -n "$VCSH_DEBUG" ]      && set -x
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+# This program is licensed under the GNU GPL version 2 or later.
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
+# For details, see LICENSE. To submit patches, you have to agree to
+# license your code under the GNU GPL version 2 or later.
+
+
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
+[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
+[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
+[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
 
 SELF=$(basename $0)
 
@@ -11,20 +22,25 @@ help() {
 
    clone <remote> \\
          [<repo>]       Clone from an existing repository
-   help                 Display this help text
    delete               Delete an existing repository
-   enter                Enter repository; spawn new $SHELL
+   enter                Enter repository; spawn new instance of \$SHELL
+   help                 Display this help text
    init <repo>          Initialize a new repository
    list                 List all repositories
+   list-tracked         List all files tracked by vcsh
+   list-tracked-by \\
+        <repo>          List files tracked by a repository
+   rename <repo> \\
+          <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
-
-   seed-gitignore \\
-   <repo>               Seed .gitignore.d/<repo> from git ls-files
    setup                Set up repository with recommended settings
+   which <substring>    Find substring in name of any tracked file
+   write-gitignore \\
+   <repo>               Write .gitignore.d/<repo> via git ls-files
 
-   <repo> <git command> Special command that allows you to run git commands
-                        directly without having to type so much ;)" >&2
+   <repo> <git command> Shortcut to run git commands directly
+   <repo>               Shortcut to enter repository" >&2
 }
 
 debug() {
@@ -35,129 +51,43 @@ verbose() {
        if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-error () {
-       echo "$SELF: error: $1" >&2
-}
-
-fatal () {
-       echo "$SELF: fatal error: $1" >&2
+fatal() {
+       echo "$SELF: fatal: $1" >&2
        exit $2
 }
 
-info () {
-       echo "$SELF: info: $1"
-}
-
-setup() {
-       git config core.worktree     "$GIT_WORK_TREE"
-       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-       git config vcsh.vcsh         'true'
-       touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-       git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-}
-
-init() {
-       verbose "init() begin"
-       [ ! -e "$GIT_DIR" ] || fatal "$GIT_DIR exists" 10
-       export GIT_WORK_TREE="$HOME"
-       mkdir -p "$GIT_WORK_TREE"
-       cd "$GIT_WORK_TREE" || fatal "could not enter $GIT_WORK_TREE" 11
-       cd "$GIT_WORK_TREE"
-       git init
-       setup
-       verbose "init() end"
+error() {
+       echo "$SELF: error: $1" >&2
 }
 
-use() {
-       verbose "use() begin"
-       if [ ! -d "$GIT_DIR" ]; then
-               error "no repository found for '$VCSH_REPO_NAME'"
-               return 12
-       fi
-       export GIT_DIR
-       export GIT_WORK_TREE="$(git config --get core.worktree)"
-       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-       verbose "use() end"
+info() {
+       echo "$SELF: info: $1"
 }
 
-
-if [ "$1" = 'clone' ]; then
-       export VCSH_COMMAND="$1"
-       GIT_REMOTE="$2"
-       export GIT_REMOTE
-       VCSH_REPO_NAME="$3"
-       [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
-       export VCSH_REPO_NAME
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
-     [ "$1" = 'enter' ] ||
-     [ "$1" = 'init' ] ||
-     [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ] ||
-     [ "$1" = 'setup' ]; then
-       [ -z $2 ] && fatal "$1: please specify repository to work on" 1
-       export VCSH_COMMAND="$1"
-       export VCSH_REPO_NAME="$2"
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       shift 2
-       export VCSH_EXTERNAL_COMMAND="$*"
-       if [ "$VCSH_COMMAND" = 'run' ]; then
-               [ -z "$VCSH_EXTERNAL_COMMAND" ] && fatal "$1 $2: please specify a command" 1
-       fi
-elif [ "$1" = 'help' ] ||
-     [ "$1" = 'list' ]; then
-       export VCSH_COMMAND="$1"
-else
-       [ -z $1 ] && help && exit 0
-       export VCSH_COMMAND='run'
-       export VCSH_REPO_NAME="$1"
-       export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       [ -d $GIT_DIR ] || { help; exit 1; }
-       shift 1
-       export VCSH_EXTERNAL_COMMAND="git $*"
-fi
-
-
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
-do
-       if [ ! -d "$check_directory" ]; then
-               if [ -e "$check_directory" ]; then
-                       fatal "$check_directory exists but is not a directory" 13
-               else
-                       info "attempting to create $check_directory"
-                       mkdir -p "$check_directory" || fatal "could not create $check_directory" 50
-               fi
-       fi
-done
-
-
-if [ "$VCSH_COMMAND" = 'clone' ]; then
-       verbose "clone begin"
+clone() {
        init
        git remote add origin "$GIT_REMOTE"
        git config branch.master.remote origin
        git config branch.master.merge  refs/heads/master
+       if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
+               info "remote is empty, not merging anything"
+               exit
+       fi
        git fetch
        for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
                [ -e "$object" ] &&
-                       error "$object exists." &&
+                       error "'$object' exists." &&
                        VCSH_CONFLICT=1;
        done
        [ "$VCSH_CONFLICT" = '1' ] &&
                fatal "will stop after fetching and not try to merge!
-  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" 17
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
        git merge origin/master
-       verbose "clone end"
-
-#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
-elif [ "$VCSH_COMMAND" = 'help' ]; then
-       help
+}
 
-elif [ "$VCSH_COMMAND" = 'delete' ]; then
-       verbose "delete begin"
-       old_dir="$PWD"
-       cd "$HOME"
-       use || exit $?
+delete() {
+       cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+       use
        info "This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
@@ -165,47 +95,106 @@ elif [ "$VCSH_COMMAND" = 'delete' ]; then
 $files
 
 AGAIN, THIS WILL DELETE YOUR DATA!
-To continue, type \"Yes, do as I say\""
+To continue, type 'Yes, do as I say'"
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || exit 16
+       [ "x$answer" = 'xYes, do as I say' ] || exit 16
        for file in $files; do
                rm -f $file || info "could not delete '$file', continuing with deletion"
        done
-       rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
-       cd "$old_dir"
-       verbose "delete end"
+       rm -r "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+}
 
-elif [ "$VCSH_COMMAND" = 'enter' ]; then
-       verbose "enter begin"
-       use || exit $?
+enter() {
+       hook pre-enter
+       use
        $SHELL
-       verbose "enter end"
+       hook post-enter
+}
 
-elif [ "$VCSH_COMMAND" = 'init' ]; then
-       verbose "init begin"
-       init
-       verbose "init end"
+git_dir_exists() {
+       [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
+}
+
+hook() {
+       for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+               [ -x "$hook" ] || continue
+               info "executing '$hook'"
+               "$hook"
+       done
+}
+
+init() {
+       [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+       export GIT_WORK_TREE="$VCSH_BASE"
+       mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
+       cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+       git init
+       setup
+}
 
-elif [ "$VCSH_COMMAND" = 'list' ]; then
-       verbose "list begin"
-       for i in "$VCSH_BASE"/*.git; do
-               echo $(basename "$i" .git)
+list() {
+       for repo in "$VCSH_REPO_D"/*.git; do
+               [ -r "$repo" ] && echo $(basename "$repo" .git)
        done
-       verbose "list end"
+}
 
-elif [ "$VCSH_COMMAND" = 'run' ]; then
-       verbose "run begin"
-       use || exit $?
+get_files() {
+       export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+       git ls-files
+}
+
+list_tracked() {
+       for VCSH_REPO_NAME in $(list); do
+               get_files
+       done | sort -u
+}
+
+list_tracked_by() {
+       use
+       git ls-files | sort -u
+}
+
+rename() {
+       git_dir_exists
+       [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+       mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+
+}
+
+run() {
+       hook pre-run
+       use
        $VCSH_EXTERNAL_COMMAND
-       verbose "run end"
-
-elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
-       verbose "seed-gitignore begin"
-       use || exit $?
-       # Switching directory as this has to be executed from $HOME to be of any use.
-       # Going back into old directory at the end in case `vcsh use` is reactivated.
-       old_dir="$PWD"
-       cd "$HOME"
+       hook post-run
+}
+
+setup() {
+       hook pre-setup
+       use
+       git config core.worktree     "$GIT_WORK_TREE"
+       git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+       git config vcsh.vcsh         'true'
+       [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+       hook post-setup
+}
+
+use() {
+       git_dir_exists
+       export GIT_WORK_TREE="$(git config --get core.worktree)"
+       export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+which() {
+       for VCSH_REPO_NAME in $(list); do
+               for VCSH_FILE in $(get_files); do
+                       echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
+               done
+       done | sort -u
+}
+
+write_gitignore() {
+       use
+       cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
        gitignores=$(for file in $(git ls-files); do
                while true; do
                        echo $file; new="${file%/*}"
@@ -214,33 +203,102 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                done;
        done | sort -u)
        tempfile=$(mktemp) || fatal "could not create tempfile" 51
-       echo '*' > "$tempfile"
+       echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
        for gitignore in $gitignores; do
-               echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
-               [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
+               echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+               if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
+                       { echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+               fi
        done
-       diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
-               rm -f "$tempfile" &&
+       if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
+               rm -f "$tempfile" || error "could not delete '$tempfile'"
                exit
-       if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
-               info "$HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
-               mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       fatal "could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" 53
        fi
-       mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               fatal "could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" 53
-       cd "$old_dir"
-       verbose "seed-gitignore end"
+       if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
+               info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
+               mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+                       fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
+       fi
+       mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
+               fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
+}
 
-elif [ "$VCSH_COMMAND" = 'setup' ]; then
-       verbose "seed-gitignore begin"
-       use   || exit $?
-       setup || exit $?
-       verbose "seed-gitignore end"
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+       fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
+fi
 
+if [ "$1" = 'clone' ]; then
+       [ -z "$2" ] && fatal "$1: please specify a remote" 1
+       export VCSH_COMMAND="$1"
+       GIT_REMOTE="$2"
+       [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+       export VCSH_REPO_NAME
+       export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'which' ]; then
+       [ -z "$2" ] && fatal "$1: please specify a filename" 1
+       [ -n "$3" ] && fatal "$1: too many parameters" 1
+       export VCSH_COMMAND="$1"
+       export VCSH_COMMAND_PARAMETER="$2"
+elif [ "$1" = 'delete' ]           ||
+     [ "$1" = 'enter' ]            ||
+     [ "$1" = 'init' ]             ||
+     [ "$1" = 'list-tracked-by' ]  ||
+     [ "$1" = 'rename' ]           ||
+     [ "$1" = 'run' ]              ||
+     [ "$1" = 'setup' ]            ||
+     [ "$1" = 'write-gitignore' ]; then
+       [ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
+       [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
+       [ "$1" = 'run' -a -z "$3" ]    && fatal "$1: please specify a command" 1
+       export VCSH_COMMAND="$1"
+       export VCSH_REPO_NAME="$2"
+       export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+       [ "$VCSH_COMMAND" = 'rename' ]         && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
+       [ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
+       [ "$VCSH_COMMAND" = 'write-gitignore' ]
+elif [ "$1" = 'list' ] ||
+     [ "$1" = 'list-tracked' ]; then
+       export VCSH_COMMAND="$1"
+elif [ -n "$2" ]; then
+       export VCSH_COMMAND='run'
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || { help; exit 1; }
+       shift 1
+       export VCSH_EXTERNAL_COMMAND="git $*"
+elif [ -n "$1" ]; then
+       export VCSH_COMMAND='enter'
+       export VCSH_REPO_NAME="$1"
+       export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+       [ -d $GIT_DIR ] || { help; exit 1; }
 else
-       verbose "defaulting to calling help()"
-       help
-       fatal "You should never reach this code. File a bug, please." 99
+       # $1 is empty, or 'help'
+       help && exit
+fi
 
+# Did we receive a directory instead of a name?
+# Mangle the input to fit normal operation.
+if echo $VCSH_REPO_NAME | grep -q '/'; then
+       export GIT_DIR=$VCSH_REPO_NAME
+       export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
 fi
+
+
+for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
+do
+       if [ ! -d "$check_directory" ]; then
+               if [ -e "$check_directory" ]; then
+                       fatal "'$check_directory' exists but is not a directory" 13
+               else
+                       info "attempting to create '$check_directory'"
+                       mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+               fi
+       fi
+done
+
+verbose "$VCSH_COMMAND begin"
+export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
+hook pre-command
+$VCSH_COMMAND
+hook post-command
+verbose "$VCSH_COMMAND end, exiting"